<?php

abstract class ffAdminScreenView extends ffBasicObject implements ffIAdminScreenView {
	
	protected $_menuSlug = null;
	
	protected $_viewName = null;
	/**
	 * 
	 * @var ffScriptEnqueuer
	 */
	protected $_scriptEnqueuer = null;
	
	/**
	 * 
	 * @var ffStyleEnqueuer
	 */
	protected $_styleEnqueuer = null;
	
	protected $_WPLayer = null;
	
	public function __construct( $menuSlug, $viewName, ffScriptEnqueuer $scriptEnqueuer, ffStyleEnqueuer $styleEnqueuer, ffWPLayer $WPLayer ) {
		$this->_menuSlug = $menuSlug;
		$this->_viewName = $viewName;
		$this->_setScriptEnqueuer($scriptEnqueuer);
		$this->_setStyleEnqueuer($styleEnqueuer);
		$this->_setWPLayer($WPLayer);
		
		$this->_getWPLayer()->getHookManager()->addActionPreEnqueueScripts( array( $this, 'requireAssets' ) );
		
		$this->_setDependencies();
	}
	
	
	public function render() {
		$this->_renderViewIdentification();
		$this->_render();
	}
	
	
	public function ajaxRequest( ffAdminScreenAjax $ajax ) {
		
	}
	
	public function requireAssets() {
		
		$this->_getScriptEnqueuer()->addScriptFramework('ff-fw-freshlib', 'framework/adminScreens/assets/js/freshlib.js', array('jquery'));
		$this->_getScriptEnqueuer()->addScriptFramework('ff-fw-adminScreens', 'framework/adminScreens/assets/js/adminScreens.js', array('jquery'));
		
		$this->_getStyleEnqueuer()->addStyleFramework('ff-admin', 'framework/adminScreens/assets/css/ff-admin.css');
		
		
		$this->_requireAssets();
	}
	
	private function _renderViewIdentification() {
		$text = '';
		$text .= '<div class="ff-view-identification" style="display:none;">';
			$text .= '<div class="admin-screen-name">'.$this->_menuSlug.'</div>';
			$text .= '<div class="admin-view-name">'.$this->_viewName.'</div>';
		$text .= '</div>';
		
		echo $text;
	}
	
	
	abstract protected function _render();
	abstract protected function _requireAssets();
	abstract protected function _setDependencies();
	

	/**
	 * @return ffScriptEnqueuer
	 */
	protected function _getScriptEnqueuer() {
		return $this->_scriptEnqueuer;
	}
	
	/**
	 * @param ffScriptEnqueuer $scriptEnqueuer
	 */
	protected function _setScriptEnqueuer(ffScriptEnqueuer $scriptEnqueuer) {
		$this->_scriptEnqueuer = $scriptEnqueuer;
		return $this;
	}
	
	/**
	 * @return ffStyleEnqueuer
	 */
	protected function _getStyleEnqueuer() {
		return $this->_styleEnqueuer;
	}
	
	/**
	 * @param ffStyleEnqueuer $styleEnqueuer
	 */
	protected function _setStyleEnqueuer(ffStyleEnqueuer $styleEnqueuer) {
		$this->_styleEnqueuer = $styleEnqueuer;
		return $this;
	}
	/**
	 * @return ffWPLayer
	 */
	protected function _getWPLayer() {
		return $this->_WPLayer;
	}
	
	protected function _setWPLayer($WPLayer) {
		$this->_WPLayer = $WPLayer;
		return $this;
	}
	
	
}