<?php

function ff_initFramework() {
	remove_action('admin_notices', 'ff_plugin_fresh_framework_notification');

	$configuration = array(
		'style_minification' => false,
		'script_minification' => false,
		'minificator' => array(
								'cache_files_max_old' =>60*60*24*7*2, // 14 days
								'cache_check_interval' => 60*60*24*3, // 3 days
							),
			
		'freshface-server-upgrading-url' => 'http://update.freshface.net/updater-server/get-info.php',
	);
	
	require_once FF_FRAMEWORK_DIR . '/framework/developingTools.php';
	require_once FF_FRAMEWORK_DIR . '/framework/fileSystem/class.ffClassLoader.php';
	
	$classLoader = new ffClassLoader();
	$classLoader->loadClass('ffBasicObject');
	$classLoader->loadClass('ffContainer');
	$classLoader->loadClass('ffFactoryAbstract');
	$classLoader->loadClass('ffPluginAbstract');
	$classLoader->loadClass('ffPluginContainerAbstract');
	
	
	$container = ffContainer::getInstance();
	$container->setConfiguration($configuration);
	$container->setClassloader($classLoader);
	
	do_action('ff_framework_initalized');
	
	// preventing to running framework when only making updates
	if( FF_FRAMEWORK_IS_INSTALLED ) {
		$container->getFramework()->run();
	}
	
}

ff_initFramework();


