<?php

class ffContainer extends ffBasicObject {
/******************************************************************************/
/* VARIABLES AND CONSTANTS
/******************************************************************************/
	private static $_instance = null;
	
	private $_configuration = null;
	
	/**
	 * 
	 * @var ffClassLoader
	 */
	private $_classLoader = null;


	/**
	 * 
	 * @var ffFileManager
	 */
	private $_fileManager= null;
	
	/**
	 * 
	 * @var ffWPLayer
	 */
	private $_WPLayer = null;
	
	/**
	 * 
	 * @var ffPluginLoader 
	 */
	private $_pluginLoader = null;
	
	
	/**
	 * 
	 * @var ffScriptEnqueuer
	 */
	private $_scriptEnqueuer = null;
	
	/**
	 *
	 * @var ffStyleEnqueuer
	 */
	private $_styleEnqueuer = null;
	
	/**
	 * 
	 * @var ffMimeTypesManager
	 */
	private $_mimeTypesManager = null;
	
	/**
	 * 
	 * @var ffOptions_Factory
	 */
	private $_optionsFactory = null;
	
	
	/**
	 * 
	 * @var ffComponent_Factory
	 */
	private $_componentFactory = null;
	
	/**
	 * 
	 * @var ffDataStorage_Factory
	 */
	private $_dataStorageFactory = null;
	
	/**
	 * 
	 * @var ffLibManager
	 */
	private $_libManager = null;
	
	/**
	 * 
	 * @var ffWidgetManager
	 */
	private $_widgetManager = null;
	
	
	/**
	 * 
	 * @var ffMenuManager
	 */
	private $_menuManager = null;
	
	/**
	 * 
	 * @var ffFileSystem
	 */
	private $_fileSystem = null;
	
	/**
	 * 
	 * @var ffDataStorage_Cache
	 */
	private $_dataStorageCache = null;
	
	/**
	 * 
	 * @var ffMinificator
	 */
	private $_minificator = null;
	
	/**
	 * 
	 * @var ffAdminScreenManager
	 */
	private $_adminScreenManager = null;
	
	/**
	 * 
	 * @var ffPluginIdentificator
	 */
	private $_pluginIdentificator = null;
	
	/**
	 * 
	 * @var ffPluginInstaller
	 */
	private $_pluginInstaller = null;
/******************************************************************************/
/* CONSTRUCT AND PUBLIC FUNCTIONS
/******************************************************************************/
	public static function getInstance() {
		if( self::$_instance == null ) {
			self::$_instance = new ffContainer();
		}
		
		return self::$_instance;
	}
	
	public function getPluginInstaller() {
		if( $this->_pluginInstaller == null ) {
			$this->getClassLoader()->loadClass('ffPluginInstaller');
		
			$this->_pluginInstaller = new ffPluginInstaller($this->getWPLayer(), $this->getFileSystem(), $this->getPluginIdentificator());
		}
		return $this->_pluginInstaller;
	}
	
	public function setConfiguration( $configuration ) {
		$this->_configuration = $configuration;
	}
	
	public function getMinificator() {
		if( $this->_minificator == null ) {
			
			$this->getClassLoader()->loadClass('externCssMin');
			$this->getClassLoader()->loadClass('externJsMinPlus');
			$this->getClassLoader()->loadClass('externJsMinPlus_Adapteur');
			$this->getClassLoader()->loadClass('ffMinificator');
			
			
			$cssMin = new CSSmin();
			$jsMinPlus = new JsMinPlus_Adapteur();
			$this->_minificator = new ffMinificator($this->getWPLayer(), $cssMin, $jsMinPlus, $this->getDataStorageCache(), $this->getFileSystem(), $this->getScriptFactory(), $this->getStyleFactory(), $this->_configuration['minificator']['cache_files_max_old'], $this->_configuration['minificator']['cache_check_interval']);
		}
		
		return $this->_minificator;
	}
	
	public function getHtaccess() {
		$this->getClassLoader()->loadClass('ffHtaccess');
		return new ffHtaccess();
	}
	
	public function getDataStorageCache() {
		if( $this->_dataStorageCache == null ) {
			$this->getClassLoader()->loadClass('ffIDataStorage');
			$this->getClassLoader()->loadClass('ffDataStorage_Cache');
			$this->_dataStorageCache = new ffDataStorage_Cache( $this->getFileSystem(), $this->getWPLayer(), $this->getDataStorageFactory()->createDataStorageWPOptionsNamespace() );
		}
		return $this->_dataStorageCache;
	}
	
	/**
	 * 
	 * @return ffLibManager
	 */
	public function getLibManager() {
		if( $this->_libManager == null ) {
			$this->getClassLoader()->loadClass('ffLibManager');
			$this->_libManager = new ffLibManager( $this->getClassLoader(), $this);
		}
		
		return $this->_libManager;
	}
	
	/**
	 * 
	 * @return ffWidgetManager
	 */
	public function getWidgetManager() {
		if( $this->_widgetManager == null ) {
			$this->getClassLoader()->loadClass('ffWidgetManager');
			$this->_widgetManager = new ffWidgetManager( $this->getWPLayer(), $this->getClassLoader() );
		}
		
		return $this->_widgetManager;
	}
	
	public function getAdminScreenAjaxFactory() {
		$this->getClassLoader()->loadClass('ffAdminScreenAjaxFactory');
		
		$adminScreenAjaxFactory = new ffAdminScreenAjax_Factory( $this->getClassLoader(), $this->getRequest());
		
		return $adminScreenAjaxFactory;
	}
	
	/**
	 * 
	 * @return ffDataStorage_Factory
	 */
	public function getDataStorageFactory() {
		if( $this->_dataStorageFactory == null ) {
			$this->getClassLoader()->loadClass('ffDataStorage_Factory');
			$this->_dataStorageFactory = new ffDataStorage_Factory( $this->getClassLoader(), $this->getWPLayer());
		}
		
		return $this->_dataStorageFactory;
	}
	
	public function getComponentFactory() {
		if( $this->_componentFactory == null ) {
			$this->getClassLoader()->loadClass('ffComponent_Factory');
			$this->getClassLoader()->loadClass('ffOptionsHolder_Factory');
			$optionsHolderFactory = new ffOptionsHolder_Factory( $this->getClassLoader(), $this->_getOneStructureFactory());
			$this->_componentFactory = new ffComponent_Factory( $this->getClassLoader(),  $optionsHolderFactory );
		}
		
		return $this->_componentFactory;
	}
	
	public function getFramework() {
		$this->getClassLoader()->loadClass('ffFramework');
		return new ffFramework( $this, $this->getPluginLoader() );
	}
	
	public function getRequest() {
		$this->getClassLoader()->loadClass('ffRequest_Factory');
		$factory = new ffRequest_Factory( $this->getClassLoader() );
		$request = $factory->createRequest();
		return $request;
	}
	
	private function _getOneStructureFactory() {
		$this->getClassLoader()->loadClass('ffOneOption_Factory');
		$this->getClassLoader()->loadClass('ffOneSection_Factory');
		$this->getClassLoader()->loadClass('ffOneStructure_Factory');
		
		$oneOptionFactory = new ffOneOption_Factory( $this->getClassLoader() );
		$oneSectionFactory = new ffOneSection_Factory( $this->getClassLoader() );
		$oneStructureFactory = new ffOneStructure_Factory( $this->getClassLoader(), $oneOptionFactory, $oneSectionFactory);
		
		return $oneStructureFactory;
	}
	
	public function getOptionsFactory() {
		if( $this->_optionsFactory == null ) {
			
			$this->getClassLoader()->loadClass('ffOptionsArrayConvertor_Factory');
			$this->getClassLoader()->loadClass('ffOptionsQuery_Factory');
			$this->getClassLoader()->loadClass('ffOptions_Factory');
			$this->getClassLoader()->loadClass('ffOptionsHolder_Factory');
			
			
			$oneStructureFactory = $this->_getOneStructureFactory();
			
			$optionsArrayConvertorFactory = new ffOptionsArrayConvertor_Factory( $this->getClassLoader() );
			$optionsQueryFactory = new ffOptionsQuery_Factory($this->getClassLoader(), $optionsArrayConvertorFactory);
			
			$optionsHolderFactory = new ffOptionsHolder_Factory( $this->getClassLoader(), $oneStructureFactory);
			
			$this->_optionsFactory = new ffOptions_Factory($oneStructureFactory, $optionsQueryFactory, $optionsHolderFactory, $this->getClassLoader() );
		}
		
		return $this->_optionsFactory;
	}
	
	public function getFileSystem() {
		if( $this->_fileSystem == null ) {
			$this->getClassLoader()->loadClass('ffFileSystem_Factory');
			$fileSystemFactory = new ffFileSystem_Factory( $this->getClassLoader() );
			$this->_fileSystem = $fileSystemFactory->createFileSystem( $this->getWPLayer() );
		}
		return $this->_fileSystem;
	}
	
	public function getFtp() {
		$this->getClassLoader()->loadClass('externDgFtp');
		$this->getClassLoader()->loadClass('ffFtp');
		
		$dgFtp = new dgFtp();
		
		$ftp = new ffFtp( $dgFtp );
		return $ftp;
	}
	
	public function getFileManager() {
		if( $this->_fileManager == null ) {
			$this->getClassLoader()->loadClass('ffFileManager_Factory');
			$factory = new ffFileManager_Factory( $this->getClassLoader() );
			$this->_fileManager = $factory->createFileManager();
		}
		
		return $this->_fileManager;
	}
	
	public function getScriptFactory() {
		$this->getClassLoader()->loadClass('ffScript_Factory');
		$factory = new ffScript_Factory( $this->getClassLoader() );
		return $factory;
	}
	
	
	public function getStyleFactory() {
		$this->getClassLoader()->loadClass('ffStyle_Factory');
		$factory = new ffStyle_Factory( $this->getClassLoader() );
		return $factory;
	}
	
	public function getStyleEnqueuer() {
		if( $this->_styleEnqueuer == null ) {
			$this->getClassLoader()->loadClass('ffStyleEnqueuer');
			
			if( $this->_configuration['style_minification'] == true) {
				$this->getClassLoader()->loadClass('ffStyleEnqueuerMinification');
				
				$this->_styleEnqueuer = new ffStyleEnqueuerMinification( $this->getWPLayer(), $this->getStyleFactory(), $this->getMinificator() );
			} else {
				$this->_styleEnqueuer = new ffStyleEnqueuer( $this->getWPLayer(), $this->getStyleFactory() );
			}
		}
		
		return $this->_styleEnqueuer;
	}
	
	public function getScriptEnqueuer() {
		if( $this->_scriptEnqueuer == null ) {
			$this->getClassLoader()->loadClass('ffScriptEnqueuer');
			
			if( $this->_configuration['script_minification'] == true) {
				$this->getClassLoader()->loadClass('ffScriptEnqueuerMinification');
				$this->_scriptEnqueuer = new ffScriptEnqueuerMinification( $this->getWPLayer(), $this->getScriptFactory(), $this->getMinificator() );
			} else {
				$this->_scriptEnqueuer = new ffScriptEnqueuer( $this->getWPLayer(), $this->getScriptFactory());
			}
		}
		
		return $this->_scriptEnqueuer;
	}	
	
	public function getMimeTypesManager() {
		if( empty( $this->_mimeTypesManager ) ){
			$this->getClassLoader()->loadClass('ffMimeTypesManager');
			$this->_mimeTypesManager = new ffMimeTypesManager( $this->getWPLayer() );
		}
		
		return $this->_mimeTypesManager;
	}
	
	public function getWPLayer() {
		if( $this->_WPLayer == null ) {
			$this->getClassLoader()->loadClass('ffWPLayer');
			$this->getClassLoader()->loadClass('ffHookManager');
			$this->_WPLayer = new ffWPLayer( FF_FRAMEWORK_URL );
			$hookManager = new ffHookManager( $this->_WPLayer);
			$this->_WPLayer->setHookManager($hookManager);			
		}		
		
		return $this->_WPLayer;
	}
	
	public function getPluginLoader() {
		if( $this->_pluginLoader == null ) {
			$this->getClassLoader()->loadClass('ffPluginLoader');
			//$factory = new ffPluginLoader_Factory( $this->getClassLoader(), $this->getWPLayer(), $this->getFileSystem(), $this );
			$this->_pluginLoader = new ffPluginLoader( $this->getWPLayer(), $this->getFileSystem(), $this, $this->getPluginIdentificator());
		}
		
		return $this->_pluginLoader;
	}
	
	public function getMenuFactory() {
		$this->getClassLoader()->loadClass('ffMenuFactory');
		$menuFactory = new ffMenuFactory( $this->getClassLoader() );
		return $menuFactory;
	}
	
	public function getMenuManager() {
		if( $this->_menuManager == null ) {
			$this->getClassLoader()->loadClass('ffMenuManager');
			$this->_menuManager = new ffMenuManager( $this->getWPLayer() );
		}
		return $this->_menuManager;
	}
	
	public function getCustomPostTypeIdentificator() {
		$this->getClassLoader()->loadClass('ffCustomPostTypeIdentificator');
		
		$this->getClassLoader()->loadClass('ffCustomPostTypeCollection_Factory');
		$this->getClassLoader()->loadClass('ffCustomPostTypeCollectionItem_Factory');
		$itemFactory = new ffCustomPostTypeCollectionItem_Factory( $this->getClassLoader() );
		$factory = new ffCustomPostTypeCollection_Factory( $this->getClassLoader(), $itemFactory );
		$customPostTypeIdentificator = new ffCustomPostTypeIdentificator( $this->getWPLayer(), $factory );
		return $customPostTypeIdentificator;
	}
	
	public function getCustomTaxonomyIdentificator() {
		$this->getClassLoader()->loadClass('ffCustomTaxonomyIdentificator');
		$this->getClassLoader()->loadClass('ffCustomTaxonomyCollection_Factory');
		$this->getClassLoader()->loadClass('ffCustomTaxonomyCollectionItem_Factory');
		$itemFactory = new ffCustomTaxonomyCollectionItem_Factory( $this->getClassLoader() );
		$factory = new ffCustomTaxonomyCollection_Factory( $this->getClassLoader(), $itemFactory, $this->getWPLayer() );
		$taxonomyIdentificator = new ffCustomTaxonomyIdentificator( $this->getWPLayer(), $factory );
		
		return $taxonomyIdentificator;
	}
	
	public function getPostGetter() {
		$this->getClassLoader()->loadClass('ffPostGetter');
		
		$postGetter = new ffPostGetter( $this->getWPLayer() );
		return $postGetter;
	}
	
	public function getTaxonomyGetter() {
		$this->getClassLoader()->loadClass('ffTaxonomyGetter');
		
		$taxonomyGetter = new ffTaxonomyGetter( $this->getWPLayer() );
		return $taxonomyGetter;
	}
	
	public function getAdminScreenManager() {
		if( $this->_adminScreenManager == null ) {
			$this->getClassLoader()->loadClass('ffMenuManager');
			$this->getClassLoader()->loadClass('ffMenuFactory');
			$this->getClassLoader()->loadClass('ffAdminScreen');
			
			$this->getClassLoader()->loadClass('ffAdminScreenViewFactory');
			$this->getClassLoader()->loadClass('ffAdminScreenFactory');
			$this->getClassLoader()->loadClass('ffAdminScreenManager');
			
			
			$adminScreenViewFactory = new ffAdminScreenViewFactory($this->getClassLoader(), $this->getRequest(), $this->getScriptEnqueuer(), $this->getStyleEnqueuer(), $this->getWPLayer() );
			$adminScreenFactory = new ffAdminScreenFactory( $this->getClassLoader(), $this->getMenuFactory(), $adminScreenViewFactory );
			$menuFactory = new ffMenuFactory( $this->getClassLoader() );
			$menuManager = new ffMenuManager($this->getWPLayer(), $menuFactory);
			$this->_adminScreenManager = new ffAdminScreenManager($this->getWPLayer(), $menuManager, $adminScreenFactory, $this->getRequest(), $this->getAdminScreenAjaxFactory() );
		}
		return $this->_adminScreenManager;
	}
	
	/**
	 * 
	 * @return ffChecksumCalculator
	 */
	public function getChecksumCalculator() {
		$this->getClassLoader()->loadClass('ffChecksumCalculator');
		return new ffChecksumCalculator( $this->getFileSystem() );
	}
	
	public function getHttp() {
		$this->getClassLoader()->loadClass('ffHttp');
		return new ffHttp( $this->getWPLayer() );
	}
	
	public function getPluginIdentificator() {
		if( $this->_pluginIdentificator == null ) {
			$this->getClassLoader()->loadClass('ffPluginIdentificator');
			$this->_pluginIdentificator = new ffPluginIdentificator( $this->getWPLayer(), $this->getFileSystem() );
		}
		
		return $this->_pluginIdentificator;
	}
	
	/**
	 * @return ffRemoteBridge
	 */
	public function getRemoteBridge() {
		$this->getClassLoader()->loadClass('ffRemoteBridge');
		$this->getClassLoader()->loadClass('ffRemoteBridgeFreshface');
		
		return new ffRemoteBridgeFreshface( $this->getHttp(), $this->getPluginIdentificator() );
	}
	
	public function getUpdateStepFactory() {
		$this->getClassLoader()->loadClass('ffUpdateStepFactory');
		
		return new ffUpdateStepFactory($this->getClassLoader(), $this->getPluginIdentificator(), $this->getHttp(), $this->getRemoteBridge(), $this->getChecksumCalculator(), $this->getFileSystem(), $this->getUpdatePluginDataFactory() );
	}
	
	public function getUpdater() {
		$this->getClassLoader()->loadClass('ffUpdater');
	
		return new ffUpdater( $this->getUpdateStepFactory() );
	}
	
	public function getUpdatePluginDataFactory() {
		$this->getClassLoader()->loadClass('ffUpdatePluginDataFactory');
		return new ffUpdatePluginDataFactory( $this->getClassLoader() );
	}
	
	public function getWPUpgrader() {
		$this->getClassLoader()->loadClass('ffWPUpgrader');
		
		return new ffWPUpgrader(
			$this->getWPLayer(),
			$this->getPluginIdentificator(),
			$this->getHttp(),
			$this->getDataStorageFactory()->createDataStorageWPOptionsNamespace(),
			$this->_configuration['freshface-server-upgrading-url']
		);
	}
	
	public function getLessParser() {
		if( !class_exists('lessc') ) {
			$this->getClassLoader()->loadClass('lessCss');
		}
		
		$less = new lessc();
		return $less;
	}
	
/******************************************************************************/
/* PRIVATE FUNCTIONS
/******************************************************************************/
	
/******************************************************************************/
/* SETTERS AND GETTERS
/******************************************************************************/	
	
	public function getClassLoader() {
		return $this->_classLoader;
	}
	
	public function setClassLoader(ffClassLoader $classLoader) {
		$this->_classLoader = $classLoader;
		return $this;
	}
	
}