<?php

class ffLibManager extends ffBasicObject {
/******************************************************************************/
/* VARIABLES AND CONSTANTS
/******************************************************************************/
	/**
	 * 
	 * @var ffContainer
	 */
	private $_container = null;
	
	/**
	 * 
	 * @var ffClassLoader;
	 */
	private $_classLoader = null;
/******************************************************************************/
/* CONSTRUCT AND PUBLIC FUNCTIONS
/******************************************************************************/
	public function __construct( ffClassLoader $classLoader, ffContainer $container ) {
		$this->_setContainer( $container );
		$this->_setClassloader($classLoader);
	}
	
	public function createTwitterFeeder() {
		$this->_getClassloader()->loadClass('ffLib_TwitterFeeder_OAuthFactory');
		$this->_getClassloader()->loadClass('ffLib_TwitterFeeder_OneTweet_Factory');
		$this->_getClassloader()->loadClass('ffLib_TwitterFeeder_TweetsCollection_Factory');
		$this->_getClassloader()->loadClass('ffLib_TwitterFeeder');
		
		$OAuthFactory = new ffLib_TwitterFeeder_OAuthFactory( $this->_getContainer()->getClassLoader() );
		$oneTweetFactory = new ffLib_TwitterFeeder_OneTweet_Factory( $this->_getContainer()->getClassLoader() );
		$tweetsCollectionFactory = new ffLib_TwitterFeeder_TweetsCollection_Factory( $this->_getContainer()->getClassLoader(), $oneTweetFactory );
		$feeder = new ffLib_TwitterFeeder( $this->_getContainer()->getDataStorageFactory()->createDataStorageWPOptions(), $OAuthFactory, $tweetsCollectionFactory);
		
		return $feeder;
	}
	
/******************************************************************************/
/* PRIVATE FUNCTIONS
/******************************************************************************/
	
/******************************************************************************/
/* SETTERS AND GETTERS
/******************************************************************************/
	/**
	 * @return ffContainer
	 */
	protected function _getContainer() {
		return $this->_container;
	}
	
	/**
	 * @param ffContainer $container
	 */
	protected function _setContainer( $container) {
		$this->_container = $container;
		return $this;
	}

	/**
	 * @return ffClassLoader;
	 */
	protected function _getClassloader() {
		return $this->_classLoader;
	}
	
	/**
	 * @param  $classLoader
	 */
	protected function _setClassloader( $classLoader) {
		$this->_classLoader = $classLoader;
		return $this;
	}
		
}