<?php

class ffWPLayer extends ffBasicObject {
	/**
	 * 
	 * @var ffHookManager
	 */
	private $_hookManager = null;
	
	private $_frameworkUrl = null;
	
	private $_cached = array();
	
	public function get_absolute_path() {
		return ABSPATH;
	}
	
	public function plugin_basename( $file ) {
		return plugin_basename( $file );
	}
	
	public function plugins_url($path = '', $plugin = '') {
		return plugins_url($path, $plugin);
	}
	
	public function getFrameworkUrl() {
		return $this->_frameworkUrl;
	}
	
	public function remove_menu_page( $menu_slug ) {
		return remove_menu_page( $menu_slug );
	}
	
	public function __construct( $frameworkUrl ) {
		$this->_frameworkUrl = $frameworkUrl;
	}
	
	public function wp_mkdir_p($path) {
		return wp_mkdir_p($path);
	}
	
	public function get_plugins( $plugin_folder = '' ) {
		return get_plugins( $plugin_folder );
	}
	
	public function wp_get_themes( $args = array() ) {
		return wp_get_themes( $args );
	}
	
	public function setHookManager( ffHookManager $hookManager ) {
		$this->_hookManager = $hookManager;
	}
	
	public function wp_remote_get( $url, $arguments = array() ) {
		return wp_remote_get($url, $arguments);
	}
	
	public function copy_dir( $from, $to, $skip_list = array() ) {
		return copy_dir( $from, $to, $skip_list );
	}
	
	public function download_url( $url, $timeout = 300 ) {
		return download_url($url, $timeout);
	}
	
	public function get_plugin_data( $plugin_file, $markup = true, $translate = true ) {
		require_once ABSPATH . '/wp-admin/includes/plugin.php';
		return get_plugin_data( $plugin_file, $markup, $translate );
	}
	
	public function get_file_data( $file, $default_headers, $context = '' ) {
		if( file_exists( $file ) ) {
			return get_file_data( $file, $default_headers, $context);
		} else {
			return null;
		}
	}
	
	public function deactivate_plugins( $plugins, $silent = false, $network_wide = null ) {
		return deactivate_plugins( $plugins, $silent, $network_wide);
	}
	
	public function activate_plugin( $plugin, $redirect = '', $network_wide = false, $silent = false ) {
		return activate_plugin( $plugin, $redirect, $network_wide, $silent);
	}
	
	public function get_wp_scripts() {
		//global $WP_Scripts;
		global $wp_scripts;
		return $wp_scripts;
	}
	
	public function get_wp_styles() {
		global $wp_styles;
		return $wp_styles;
	}
	
	public function set_wp_scripts($wp_scripts_new) {
		global $wp_scripts;
		$wp_scripts = $wp_scripts_new;
	}
	
	public function set_wp_styles( $wp_styles_new ) {
		global $wp_styles;
		$wp_styles = $wp_styles_new;
	}
	
	public function get_site_url( $blog_id = null, $path = '', $scheme = null ) {
		return get_site_url($blog_id, $path, $scheme );
	}
	
	/**
	 * 
	 * @return ffHookManager
	 */
	public function getHookManager() {
		return $this->_hookManager;
	}
	
	public function is_login_page() {
		return in_array($GLOBALS['pagenow'], array('wp-login.php', 'wp-register.php'));
	}
	
	public function add_action($tag, $function_to_add, $priority = 10, $accepted_args = 1) {
		return add_action( $tag, $function_to_add, $priority, $accepted_args );
	}
	
	public function add_filter( $tag, $function_to_add, $priority = 10, $accepted_args = 1 ) {
		return add_filter($tag, $function_to_add, $priority, $accepted_args);
	}
	
	public function get_terms( $taxonomies, $args ) {
		return get_terms( $taxonomies, $args );
	}
	
	public function get_plugin_base_dir() {
		return WP_PLUGIN_DIR;
	}
	
	public function get_WP_filesystem() {
		global $wp_filesystem;
		return $wp_filesystem;
	}
	
	function wp_upload_dir() {
		return wp_upload_dir();
	}
	
	function get_home_url() {
		if( !isset( $this->_cached['get_home_url'] ) ) {
			$this->_cached['get_home_url'] = get_home_url(); 
		}
		return $this->_cached['get_home_url'];
	}
	
	function get_home_path() {
		if( !isset( $this->_cached['get_home_path'] ) ) {
			$this->_cached['get_home_path'] = get_home_path();
		}
		return $this->_cached['get_home_path'];
	}
	
	public function WP_Filesystem() {
		require_once(ABSPATH .'/wp-admin/includes/file.php');
		return WP_Filesystem();
	}
	
	public function is_admin() {
		return is_admin();
	}
	
	public function action_enqueue_scripts_name() {
		if( $this->is_admin() ) {
			return 'admin_enqueue_scripts';
		} else {
			return 'wp_enqueue_scripts';
		}
	}
	
	public function add_action_enque_scripts( $callback ) {
		if( $this->is_admin() ) {
			$this->add_action('admin_enqueue_scripts', $callback);
		} else {
			$this->add_action('wp_enqueue_scripts', $callback);
		}
	}
	
	public function wp_enqueue_script( $handle, $src = false, $deps = array(), $ver = false, $in_footer = false ) {
		wp_enqueue_script( $handle, $src, $deps, false, $in_footer);
	}
	
	public function wp_enqueue_style( $handle, $src = false, $deps = array(), $media = 'all' )  {
		wp_enqueue_style( $handle, $src, $deps, false, $media);
	}
	
	public function add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function = '', $icon_url = '', $position = null ) {
		add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function, $icon_url, $position);
	}
	
	public function add_submenu_page( $parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function = '' ) {
		add_submenu_page($parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function);
	}
	
	public function do_action($tag, $arg='') {
		do_action($tag, $arg);
	}
	
	/*global $merged_filters, $wp_current_filter;
	 var_dump($merged_filters);
	vaR_dump( $wp_current_filter);*/
	public function action_been_executed( $actionName ) {
		global $merged_filters;
	
		if( isset( $merged_filters[ $actionName ] ) ) {
			return true;
		} else {
			return false;
		}
	}
	
	public function update_option($name, $value ) {
		return update_option( $name, $value );
	}
	
	public function delete_option( $name ) {
		return delete_option( $name );
	}
	
	public function get_option( $name, $default = null ) {
		return get_option( $name, $default );
	}
	
	public function get_wp_plugin_dir() {
		return WP_PLUGIN_DIR;
	}
	
	public function get_wp_post_types() {
		global $wp_post_types;
		return $wp_post_types;
	}
	
	public function get_taxonomies(  $args = array(), $output = 'names', $operator = 'and' ) {
		return get_taxonomies( $args, $output, $operator );
	}
	
	public function get_taxonomy( $taxonomy ) {
		return get_taxonomy($taxonomy );
	}
	
	public function get_posts( $args ) {
		return get_posts( $args );
	}
	
	public function get_wp_registered_sidebars() {
		global $wp_registered_sidebars;
		return $wp_registered_sidebars;
	}
	
	public function set_wp_registered_sidebars( $registeredSidebars ) {
		global $wp_registered_sidebars;
		$wp_registered_sidebars = $registeredSidebars;
	}
	
	public function createWpDependency(  $handle = null, $src = null, $deps = null, $ver = null, $args = null ) {
		return new _WP_Dependency( $handle, $src, $deps, $ver, $args );
	}
}