<?php

class ffDataStorage_Factory extends ffFactoryAbstract {
	/**
	 * 
	 * @var ffWPLayer
	 */
	private $_WPLayer = null;

	
	public function __construct(ffClassLoader $classLoader, ffWPLayer $WPLayer ) {
		$this->_setWplayer($WPLayer);
		parent::__construct($classLoader);
	}
	
	/**
	 * 
	 * @return ffDataStorage_WPOptions
	 */
	public function createDataStorageWPOptions() {
		$this->_getClassloader()->loadClass('ffIDataStorage');
		$this->_getClassloader()->loadClass('ffDataStorage');
		$this->_getClassloader()->loadClass('ffDataStorage_WPOptions');
		$dataStorage = new ffDataStorage_WPOptions( $this->_getWplayer() );
		return $dataStorage;
	}
	
	public function createDataStorageWPOptionsNamespace( $namespace = null ) {
		$this->_getClassloader()->loadClass('ffDataStorage_WPOptions_NamespaceFacade');
			
		$WPOptions = $this->createDataStorageWPOptions();
		
		$WPOptions_NamespaceFacade = new ffDataStorage_WPOptions_NamespaceFacede($WPOptions, $namespace);
		
		return $WPOptions_NamespaceFacade;
	}

	
	/**
	 * @return ffWPLayer
	 */
	protected function _getWplayer() {
		return $this->_WPLayer;
	}
	
	/**
	 * @param ffWPLayer $WPLayer
	 */
	protected function _setWplayer(ffWPLayer $WPLayer) {
		$this->_WPLayer = $WPLayer;
		return $this;
	}
	
	
	
}