<?php
class ffOneOption extends ffBasicObject implements ffIOneDataNode {
	const TYPE_TEXT = 'text';
	const TYPE_TEXTAREA = 'textarea';
	const TYPE_NUMBER = 'number';
	const TYPE_SELECT = 'select';
	const TYPE_CHECKBOX = 'checkbox';
	
	private $_type = null;
	private $_id = null;
	private $_title = null;
	private $_defaultValue = null;
	private $_description = null;
	
	private $_selectValues = null;
	private $_params = null;
	private $_value = null;

/******************************************************************************/
/* CONSTRUCT AND PUBLIC FUNCTIONS
/******************************************************************************/	
	public function __construct( $type = null, $id = null, $title = null, $defaultValue = null, $description = null ) {
		$this->_type = $type;
		$this->_id = $id;
		$this->_title = $title;
		$this->_defaultValue = $defaultValue;
		$this->_description = $description;
	}
	
	public function addSelectValue( $name, $value ) {
		$newValue = array( 'name' => $name, 'value' => $value );
		$this->_selectValues[] = $newValue;
		
		return $this;
	}
	
	public function addParam( $name, $value ) {
		
		//$newParam = array( 'name' => $name, 'value' => $value );
		$this->_params[ $name ][] = $value;
		return $this;
	}
	
	public function getDefaultValue() { return $this->_defaultValue; }

	
	public function getValue() {return $this->_value;}
	public function setValue( $value ) { $this->_value = $value; }
	
	public function getTitle() { return $this->_title; }
	public function getType() { return $this->_type; }
	
	public function getDescription() { return $this->_description; }
	
	public function getSelectValues() { return $this->_selectValues; }
	
	public function getParam( $name ) {
		if( isset( $this->_params[$name ] ) ) {
			if( count( $this->_params[ $name ]) == 1 ) {
				return reset( $this->_params[ $name ] );
			} else {
				return $this->_params[ $name ];
			}
		}
		
		return null;
	}
/******************************************************************************/
/* IOneDataNode IMPLEMENTATION
/******************************************************************************/	
	public function getId() { return $this->_id; }
	
	public function isContainer() {
		return false;
	}
	
	
}