<?php
class ffOneSection extends ffBasicObject implements ffIOneDataNode {
	const TYPE_REPEATABLE = 'repeatable';
	const TYPE_NORMAL = 'normal';

	private $_id = null;
	private $_data = array();
	private $_params = null;

	private $_type = null;

	/******************************************************************************/
	/* CUSTOM FUNCTIONS
	 /******************************************************************************/
	public function __construct( $id = null, $type = null ) {
		$this->_id = $id;
		$this->_type = $type;
	}

	public function addOption( ffOneOption $option ) {
		$this->_data[] = $option;
	}
	
	public function addElement( ffOneElement $element ) {
		$this->_data[] = $element;
	}

	public function addSection( ffOneSection $section ) {
		$this->_data[] = $section;
	}

	public function addParam( $name, $value ) {
		$this->_params[$name][] = $value;
	}

	public function getData() {
		return $this->_data;
	}

	public function getType() {
		return $this->_type;
	}
	/******************************************************************************/
	/* IOneDataNode IMPLEMENTATION
	 /******************************************************************************/

	public function getId() {
		return $this->_id;
	}
	
	public function isContainer() {
		return true;
	}
}