<?php

class ffOptionsQuery_Factory extends ffFactoryAbstract {
	/**
	 * 
	 * @var ffOptionsArrayConvertor_Factory
	 */
	private $_optionsArrayConvertorFactory = null;
	
	public function __construct( ffClassLoader $classLoader, ffOptionsArrayConvertor_Factory $optionsArrayConvertorFactory ) {
		$this->_setOptionsarrayconvertorfactory($optionsArrayConvertorFactory);
		parent::__construct($classLoader);
	}
	
	public function createOptionsQuery( $data, $structures = null ) {
		$this->_getClassloader()->loadClass('ffOptionsQuery');
		$arrayConvertor = $this->_getOptionsarrayconvertorfactory()->createArrayConvertor();
		
		$query = new ffOptionsQuery($data, $structures, $arrayConvertor );
		return $query;
	}


	/**
	 * @return ffOptionsArrayConvertor_Factory
	 */
	protected function _getOptionsarrayconvertorfactory() {
		return $this->_optionsArrayConvertorFactory;
	}
	
	/**
	 * @param ffOptionsArrayConvertor_Factory $optionsArrayConvertorFactory
	 */
	protected function _setOptionsarrayconvertorfactory(ffOptionsArrayConvertor_Factory $optionsArrayConvertorFactory) {
		$this->_optionsArrayConvertorFactory = $optionsArrayConvertorFactory;
		return $this;
	}
	
}