<?php

class ffOptions_Factory extends ffFactoryAbstract {
	/**
	 * 
	 * @var ffOneStructure_Factory
	 */
	private $_oneStructureFactory = null;
	
	/**
	 * 
	 * @var ffOptionsQuery_Factory
	 */
	private $_optionsQueryFactory = null;
	
	/**
	 * 
	 * @var ffOptionsHolder_Factory
	 */
	private $_optionsHolderFactory = null;
	
	/**
	 * 
	 * @var ffOptionsPrinterComponent_Factory
	 */
	private $_printerComponentFactory = null;
	
	public function __construct( ffOneStructure_Factory $oneStructureFactory, ffOptionsQuery_Factory $optionsQueryFactory, ffOptionsHolder_Factory $optionsHolderFactory, ffClassLoader $classLoader ) {
		$this->_setOnestructurefactory($oneStructureFactory);
		$this->_setOptionsqueryfactory($optionsQueryFactory);
		$this->_setOptionsholderfactory($optionsHolderFactory);
		
		parent::__construct($classLoader);
	}
	
	public function createOptionsPrinter(  $optionsArrayData = null, $optionsStructure = null ) {
		$this->_getClassloader()->loadClass('ffOptionsPrinterComponent_Factory');
		$this->_getClassloader()->loadClass('ffOptionsWalker');
		$this->_getClassloader()->loadClass('ffOptionsPrinter');
		
		
		if( $this->_getPrintercomponentfactory() == null ) {
			$this->_setPrintercomponentfactory( new ffOptionsPrinterComponent_Factory( $this->_getClassloader()) );
		}
		
		
		
		$optionsPrinter = new ffOptionsPrinter( $optionsArrayData, $optionsStructure, $this->_getPrintercomponentfactory() );
		
		return $optionsPrinter;
		
	}
	
	/**
	 * 
	 * @return ffIOptionsHolder
	 */
	public function createOptionsHolder( $optionsHolderName ){
		return $this->_getOptionsholderfactory()->createOptionsHolder( $optionsHolderName );
	}
	
	public function createStructure( $name ) {
		$structure = $this->_getOnestructurefactory()->createOneStructure($name);
		return $structure;
	}
	
	public function createQuery( $data, $structures ) {
		$query = $this->_getOptionsqueryfactory()->createOptionsQuery($data, $structures);
		return $query;
	}

	/**
	 * @return ffOneStructure_Factory
	 */
	protected function _getOnestructurefactory() {
		return $this->_oneStructureFactory;
	}
	
	/**
	 * @param ffOneStructure_Factory $_oneStructureFactory
	 */
	protected function _setOnestructurefactory(ffOneStructure_Factory $oneStructureFactory) {
		$this->_oneStructureFactory = $oneStructureFactory;
		return $this;
	}

	protected function _getOptionsqueryfactory() {
		return $this->_optionsQueryFactory;
	}
	
	protected function _setOptionsqueryfactory(ffOptionsQuery_Factory $optionsQueryFactory) {
		$this->_optionsQueryFactory = $optionsQueryFactory;
		return $this;
	}

	/**
	 * @return ffOptionsHolder_Factory
	 */
	protected function _getOptionsholderfactory() {
		return $this->_optionsHolderFactory;
	}
	
	/**
	 * @param ffOptionsHolder_Factory $optionsHolderFactory
	 */
	protected function _setOptionsholderfactory(ffOptionsHolder_Factory $optionsHolderFactory) {
		$this->_optionsHolderFactory = $optionsHolderFactory;
		return $this;
	}

	/**
	 * @return ffOptionsPrinterComponent_Factory
	 */
	protected function _getPrintercomponentfactory() {
		return $this->_printerComponentFactory;
	}
	
	/**
	 * @param ffOptionsPrinterComponent_Factory $_printerComponentFactory
	 */
	protected function _setPrintercomponentfactory(ffOptionsPrinterComponent_Factory $printerComponentFactory) {
		$this->_printerComponentFactory = $printerComponentFactory;
		return $this;
	}
	
	
	
	
}