<?php
/******************************************************************************/
/* TYPE TEXT
/******************************************************************************/
class ffOptionsPrinterComponent_Text extends ffBasicObject {
	public function printOption( ffOneOption $oneOption, $nameRoute, $idRoute ) {
		echo '<label for="thumbnail_size_w">'.$oneOption->getTitle().'</label>'.' ';
		echo '<input type="text" class="small-text" id="thumbnail_size_w" name="'.$nameRoute.'" class="'.$idRoute.$oneOption->getId().'" value="'.$oneOption->getValue().'">';
	}
}


/******************************************************************************/
/* TYPE TEXTAREA
/******************************************************************************/
class ffOptionsPrinterComponent_Textarea extends ffBasicObject {
	public function printOption( ffOneOption $oneOption, $nameRoute, $idRoute ) {
		$rows = $oneOption->getParam('rows');
		$cols = $oneOption->getParam('cols');
		
		if( empty( $rows ) ) {
			$rows = 5;
		}
		
		if( empty( $cols ) ) {
			$cols = 30;
		}
		
		echo '<textarea name="description" id="description" rows="'.$rows.'" cols="'.$cols.'">'.$oneOption->getValue().'</textarea>';
		echo '<span class="description">'.$oneOption->getDescription().'</span>';
	}
}

/******************************************************************************/
/* TYPE NUMBER
/******************************************************************************/
class ffOptionsPrinterComponent_Number extends ffBasicObject {
	public function printOption( ffOneOption $oneOption, $nameRoute, $idRoute ) {

		echo '<label for="thumbnail_size_w">'.$oneOption->getTitle().'</label>'.' ';
		echo '<input type="number" class="small-text" id="thumbnail_size_w" name="'.$nameRoute.'" class="'.$idRoute.$oneOption->getId().'" value="'.$oneOption->getValue().'">';
	}
}

/******************************************************************************/
/* TYPE CHECKBOX
/******************************************************************************/
class ffOptionsPrinterComponent_Checkbox extends ffBasicObject {
	public function printOption( ffOneOption $oneOption, $nameRoute, $idRoute ) {
		$checked = '';
		if( $oneOption->getValue() == 1 ) {
			$checked = 'checked="checked"';
		} 
		
		
		if( ($oneOption->getTitle()) )
			echo '<label for="'.$idRoute.$oneOption->getId().'">';
			
		echo '<input type="hidden" id="'.$idRoute.$oneOption->getId().'-hidden" value="0" name="'.$nameRoute.'">'."\n";
		
		//if( ($oneOption->getDescription()) )
			//echo '<label for="'.$idRoute.$oneOption->getId().'">'.$oneOption->getDescription().'</label>'."\n";
		
		echo '<input type="checkbox" '.$checked.' value="1" id="'.$idRoute.$oneOption->getId().'" name="'.$nameRoute.'">'."\n";
		
		if( ($oneOption->getTitle()) )
			echo $oneOption->getTitle().'</label>'."\n";
		
		
	}
}

/******************************************************************************/
/* TYPE SELECT
/******************************************************************************/
class ffOptionsPrinterComponent_Select extends ffBasicObject {
	public function printOption( ffOneOption $oneOption, $nameRoute, $idRoute ) {
		$selectValues = $oneOption->getSelectValues();
		$selectedValue = $oneOption->getValue();
		echo '<label for="page_on_front">'.$oneOption->getTitle().'<select id="'.$idRoute.$oneOption->getId().'" name="'.$nameRoute.'" >';
		
			if( !empty( $selectValues ) ) {
				foreach( $selectValues as $oneValue ) {
					$selected = '';
					if( $oneValue['value'] == $selectedValue ) {
						$selected = ' selected="selected" ';
					}
					echo '<option value="'.$oneValue['value'].'" '.$selected.'>'.$oneValue['name'].'</option>';
				}
			}
		echo '</select>';
	}
}