<?php

class ffOptionsPrinterElement_TableStart extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		$classParam = $element->getParam('class');
		
		echo '<table class="form-table '.$classParam.'"><tbody>';
	}
}


class ffOptionsPrinterElement_TableEnd extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		echo '</tbody></table>';
	}
}


class ffOptionsPrinterElement_TableHeader extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		$classParam = $element->getParam('class');
		$class = '';
		if( $classParam != null ) {
			$class = ' class="'.$classParam.'" ';
		}
		echo '<th '.$class.' scope="row">'.$element->getTitle().'</th>';
	}
}

class ffOptionsPrinterElement_TableDataStart extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		$classParam = $element->getParam('class');
		$class = '';
		if( $classParam != null ) {
			$class = ' class="'.$classParam.'" ';
		}
		
		echo '<tr '.$class .'>';
		if( strlen($element->getTitle()) > 0 )
			echo '<th scope="row">'.$element->getTitle().'</th>';
		echo '<td><fieldset>';
	}
}

class ffOptionsPrinterElement_TableDataEnd extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		echo '</fieldset></td>';
		echo '</tr>';
	}
}

class ffOptionsPrinterElement_NewLine extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		echo '<br/>';
	}
}

class ffOptionsPrinterElement_Html extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		echo $element->getTitle();
	}
}

class ffOptionsPrinterElement_Button extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		echo '<input type="submit" value="'.$element->getTitle().'" class="button button-secondary button-small" id="'.$element->getId().'" name="submit"><span class="'.$element->getId().'_spinner spinner"></span>';
	}
}

class ffOptionsPrinterElement_Heading extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		$type = $element->getParam('heading_type', 'h3');
		
		echo '<'.$type.'>';
			echo $element->getTitle();
		echo '</'.$type.'>';
		//echo '<'
		//echo '<div class="'.$element->getId().'"><input type="submit" value="'.$element->getTitle().'" class="button button-secondary button-small" id="'.$element->getId().'" name="submit"><span class="spinner"></span></div>';
	}
}


class ffOptionsPrinterElement_Paragraph extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		echo '<p>';
		echo $element->getTitle();
		echo '</p>';
	}
}

class ffOptionsPrinterElement_Description extends ffBasicObject {
	public function printElement( ffOneElement $element ) {
		echo '<p class="description">';
		echo $element->getTitle();
		echo '</p>';
	}
}