<?php

class ffCustomPostTypeIdentificator extends ffBasicObject {
/******************************************************************************/
/* VARIABLES AND CONSTANTS
/******************************************************************************/
	/**
	 * 
	 * @var ffWPLayer
	 */
	protected  $_WPLayer = null;
	
	/**
	 * 
	 * @var ffCustomPostTypeCollection_Factory
	 */
	protected $_customPostTypeCollectionFactory = null;
	
	
	protected  $_postTypeBlacklist = array();
/******************************************************************************/
/* CONSTRUCT AND PUBLIC FUNCTIONS
/******************************************************************************/

	public function __construct( ffWPLayer $WPLayer, ffCustomPostTypeCollection_Factory $customPostTypeCollectionFactory ) {
		$this->_setWPLayer($WPLayer);
		$this->_setCustomPostTypeCollectionFactory($customPostTypeCollectionFactory);
		
		$this->addWordpressDefaultBlacklist();
	}
	
	public function getActivePostTypesCollection() {
		$activePostTypesArray = $this->_getWPLayer()->get_wp_post_types();
		$activePostTypesAfterBlacklist = $this->_filterBlacklistedPostTypes( $activePostTypesArray );
		return $this->_getCustomPostTypeCollectionFactory()->createCustomPostTypeCollection( $activePostTypesAfterBlacklist );
	}
	
	public function addWordpressDefaultBlacklist() {
		$this->addBlacklistedPostType('revision');
		$this->addBlacklistedPostType('attachment');
		$this->addBlacklistedPostType('nav_menu_item');
	}
	
	public function resetBlacklist() {
		$this->_postTypeBlacklist = array();
	}
	
	public function addBlacklistedPostType( $postType ) {
		$this->_postTypeBlacklist[] = $postType;
	}
/******************************************************************************/
/* PRIVATE FUNCTIONS
/******************************************************************************/
	private function _filterBlacklistedPostTypes( $postTypes ) {
		if( empty($this->_postTypeBlacklist) ) return $postTypes;
		
		foreach( $this->_postTypeBlacklist as $blacklistedPostType ) {
			if( isset( $postTypes[ $blacklistedPostType] ) ) {
				unset( $postTypes[ $blacklistedPostType ] );
			}
		}
		
		return $postTypes;
	}
/******************************************************************************/
/* SETTERS AND GETTERS
/******************************************************************************/	

	
	/**
	 * @return ffWPLayer
	 */
	protected function _getWPLayer() {
		return $this->_WPLayer;
	}
	
	/**
	 * @param ffWPLayer $WPLayer
	 */
	protected function _setWPLayer(ffWPLayer $WPLayer) {
		$this->_WPLayer = $WPLayer;
		return $this;
	}

	/**
	 * @return ffCustomPostTypeCollection_Factory
	 */
	protected function _getCustomPostTypeCollectionFactory() {
		return $this->_customPostTypeCollectionFactory;
	}
	
	/**
	 * @param ffCustomPostTypeCollection_Factory $customPostTypeCollectionFactory
	 */
	protected function _setCustomPostTypeCollectionFactory(ffCustomPostTypeCollection_Factory $customPostTypeCollectionFactory) {
		$this->_customPostTypeCollectionFactory = $customPostTypeCollectionFactory;
		return $this;
	}
	
}