<?php
/*
Plugin Name: Fresh Performance Cache (shared on wplocker.com)
Plugin URI: http://freshface.net
Description: Boost your WordPress site performance by minifying, combining, compressing and caching your files.
Version: 1.0.1
Author: FRESHFACE
Author URI: http://freshface.net
*/
?>

<?php
if( file_exists( dirname(__FILE__).'/framework/fresh-framework/freshplugin.php') ) {
	// require framework
	
	require_once  dirname(__FILE__).'/framework/fresh-framework/noerror.php';
	require_once  dirname(__FILE__).'/framework/fresh-framework/freshplugin.php';

	add_action('ff_framework_initalized', 'ff_auto_install');
	/**
	 * This function manages auto installation. Firstly it install all plugins
	 * After that it install framework (if we don't have the latest version).
	 * After that goes activation ( we must activate after everything is 
	 * installed )
	 */
	function ff_auto_install() {
		//return
		
		$c = ffContainer::getInstance();
		// we have to load object WPLayer into memory, in case we will be deleting
		// framework;
		$c->getWPLayer();
		$c->getPluginInstaller();
		
		// get list of auto installed plugins
		$installedPlugins = ff_auto_install_plugins();
		// install framework if we have to ( it's not there, or older )
		$installedFramework = ff_auto_install_framework();
		
		$c->getPluginInstaller()->activateInstalledPlugins();
		
		$pluginDir = basename( dirname(__FILE__) ) .'/index.php';
		
		$c->getWPLayer()->deactivate_plugins( $pluginDir );
		
		$c->getFileSystem()->delete( dirname(__FILE__), true);
	
		
		echo '<script>location.reload();</script>';
	}
	
	function ff_auto_install_framework() {
		$c = ffContainer::getInstance();
		$dir = dirname(__FILE__);
		$c->getPluginInstaller()->installPluginFromFolder(  $dir .'/framework/fresh-framework' );
		/*
		$c = ffContainer::getInstance();
		$dir = dirname(__FILE__);
		
		// get latest INSTALLED version, different than framework called
		// from this plugin, it's only REGISTERED.
		$latestInstalledVersion = ffFrameworkVersionManager::getInstance()->getLatestInstalledVersion();
		// needed for get_plugin_data calling
		require_once ABSPATH . '/wp-admin/includes/plugin.php';
		// get plugin info for this framework. We are mainly looking for the version
		$thisFrameworkData = get_plugin_data( $dir.'/framework/fresh-framework/freshplugin.php');
		$thisFrameworkVersion = $thisFrameworkData['Version'];
		
		if( ( $latestInstalledVersion == null ) || ( $latestInstalledVersion < $thisFrameworkVersion ) ) {
			DEFINE(FF_FRAMEWORK_INSTALLING, true);
			$currentFrameworkDir = $c->getWPLayer()->get_plugin_base_dir() .'/fresh-framework';
			$thisFrameworkDir = $dir .'/framework/fresh-framework';
			
			// is there any framework ? lets delete it
			if( $latestInstalledVersion != null ) {
				$c->getWPLayer()->deactivate_plugins('fresh-framework/freshplugin.php');
				$c->getFileSystem()->delete( $currentFrameworkDir, true);
			}
			
			$c->getFileSystem()->move( $thisFrameworkDir, $currentFrameworkDir, true);
			
			return 'fresh-framework/freshplugin.php';
		}
		
		return null;*/
	}
	
	function ff_auto_install_plugins() {
		// container is a classs which creates all other classes :)
		$c = ffContainer::getInstance();
		$dir = dirname(__FILE__);
		
		// get all files from folder "plugins" directly in this plugin
		$pluginsToInstall = $c->getFileSystem()->dirlist( $dir .'/plugins/');
		
		
		// we have to activate AFTER all plugins installed, because calling
		// activate_plugin triggers caching of the directory
		$installedPluginsWaitingForActivation = array();
		
		if( empty( $pluginsToInstall ) ) {
			return false;
		}
		// loop through all the plugins and move them info the
		// wp-content/plugins folder, IF they are newer than current
		// plugin installed
		foreach( $pluginsToInstall as $name => $onePlugin ){
			// if it's not directory, then skip
			if( $onePlugin['type'] !== 'd') {
				continue;
			} 
			$c->getPluginInstaller()->installPluginFromFolder(  $dir .'/plugins/'.$name );
			/*
			$currentPluginInfo =  $c->getPluginIdentificator()->getOurPluginInfo( $name );
			$newPluginInfo = $c->getWPLayer()->get_plugin_data( $dir .'/plugins/'.$name.'/freshplugin.php');
			
			// when not installed, OR lower version installed
			if( ( $currentPluginInfo == false ) || ( $currentPluginInfo['Version'] < $newPluginInfo['Version'] ) ) {
				$currentPluginDir = $c->getWPLayer()->get_plugin_base_dir() .'/'.$name;
				$newPluginDir = $dir . '/plugins/' . $name;
				
				// deactivate the old plugin
				$c->getWPLayer()->deactivate_plugins( $name.'/freshplugin.php' );
				
				// delete the old folder with the plugin
				$c->getFileSystem()->delete( $currentPluginDir, true);
				$c->getFileSystem()->move( $newPluginDir, $currentPluginDir );
				
				$installedPluginsWaitingForActivation[] = $name . '/freshplugin.php';
			}*/
		}
		
	}
}